////////////////////////////////////////////////////////////
// CANVAS
////////////////////////////////////////////////////////////
var stage
var canvasW=0;
var canvasH=0;

/*!
 * 
 * START GAME CANVAS - This is the function that runs to setup game canvas
 * 
 */
function initGameCanvas(w,h){
	canvasW=w;
	canvasH=h;
	stage = new createjs.Stage("gameCanvas");
	
	createjs.Touch.enable(stage);
	stage.enableMouseOver(20);
	stage.mouseMoveOutside = true;
	
	createjs.Ticker.setFPS(60);
	createjs.Ticker.addEventListener("tick", tick);	
}

var canvasContainer, mainContainer, gameContainer, objectContainer, resultPopContainer, planetContainer;
var planet1, planet2, drag, bg, landing, btnStart, planetGreen, planetRed, planetYellow, planetAlert, planetCrack1, planetCrack2, planetCrack3, planetChart1, planetChart2, planetChart3, colourAnimation, colourGreenAnime, colourRedAnime, colourYellowAnime, colourGreenData, colourRedData, colourYellowData, txtScoreDesc, txtScore, bgPop, bgOverlay, btnHome, btnReplay, btnFacebook, btnTwitter, btnGoogle, txtShare, txtResultScore, txtResultScoreDesc;
var txtExtra=0;

/*!
 * 
 * BUILD GAME CANVAS ASSERTS - This is the function that runs to build game canvas asserts
 * 
 */
function buildGameCanvas(){
	canvasContainer = new createjs.Container();
	
	bg = new createjs.Bitmap(loader.getResult("bg"));
	landing = new createjs.Bitmap(loader.getResult("landing"));
	
	btnStart = new createjs.Bitmap(loader.getResult("btnStart"));
	centerReg(btnStart);
	btnStart.x=canvasW/2;
	btnStart.y=canvasH/100*65;
	
	planetContainer = new createjs.Container();
	gameContainer = new createjs.Container();
	objectContainer = new createjs.Container();
	mainContainer = new createjs.Container();
	
	planetGreen = new createjs.Bitmap(loader.getResult("planetGreen"));
	planetRed = new createjs.Bitmap(loader.getResult("planetRed"));
	planetYellow = new createjs.Bitmap(loader.getResult("planetYellow"));
	
	planetCrack1 = new createjs.Bitmap(loader.getResult("planetCrack1"));
	planetCrack2 = new createjs.Bitmap(loader.getResult("planetCrack2"));
	planetCrack3 = new createjs.Bitmap(loader.getResult("planetCrack3"));
	
	planetAlert = new createjs.Bitmap(loader.getResult("planetAlert"));
	planetAlert.alpha=0;
	
	centerReg(planetAlert);
	
	centerReg(planetGreen);
	centerReg(planetRed);
	centerReg(planetYellow);
	
	centerReg(planetCrack1);
	centerReg(planetCrack2);
	centerReg(planetCrack3);
	
	planetContainer.addChild(planetAlert, planetGreen, planetRed, planetYellow, planetCrack1, planetCrack2, planetCrack3);
	
	planet1 = new createjs.Shape();
	planet2 = new createjs.Shape();
	drag = new createjs.Shape();
	
	planet1.graphics.beginFill("black").drawCircle(0, 0, 100);
	planet2.graphics.beginFill("black").drawCircle(0, 0, 100);
	drag.graphics.beginFill("black").drawCircle(0, 0, 100);
	
	planet1.x = canvasW/2;
	planet1.y = canvasH/2;
	planet2.x = canvasW/2;
	planet2.y = canvasH/2;
	drag.x = canvasW/2;
	drag.y = canvasH/2;
	planet1.visible=planet2.visible=drag.visible=false;
	
	planetChart1 = new createjs.Shape();
	planetChart2 = new createjs.Shape();
	planetChart3 = new createjs.Shape();
	
	planetGreen.mask = planetChart1;
	planetRed.mask = planetChart2;
	planetYellow.mask = planetChart3;
	planetChart1.visible=planetChart2.visible=planetChart3.visible=false;
	
	planetContainer.addChild(planetChart1, planetChart2, planetChart3);
	
	planetContainer.x = canvasW/2;
	planetContainer.y = canvasH/2;
	
	var _frameW=80;
	var _frameH=72;
	var _frame = {"regX": (_frameW/2), "regY": (_frameH/2), "height": _frameH, "count": 7, "width": _frameW};
	colourAnimation = {static:{frames: [0,1], speed: .1},
				   	touchwin:{frames: [2,5], speed: .1, next: "win"},
					win:[5],
					touchfail:{frames: [6], speed: .1, next: "dead"},
					dead:[6]};
					
	colourGreenData = new createjs.SpriteSheet({
		"images": [loader.getResult("colourGreenAnime").src],
		"frames": _frame,
		"animations": colourAnimation
	});
	
	colourRedData = new createjs.SpriteSheet({
		"images": [loader.getResult("colourRedAnime").src],
		"frames": _frame,
		"animations": colourAnimation
	});
					
	colourYellowData = new createjs.SpriteSheet({
		"images": [loader.getResult("colourYellowAnime").src],
		"frames": _frame,
		"animations": colourAnimation
	});
	
	txtScoreDesc = new createjs.Text();
	txtScoreDesc.font = "50px jabjaiheavy";
	txtScoreDesc.textAlign = "left";
	txtScoreDesc.text = gameScoreText;
	txtScoreDesc.color = "#ffffff";
	txtScoreDesc.x=30;
	txtScoreDesc.y=30;
	
	txtScore = new createjs.Text();
	txtScore.font = "50px jabjaiheavy";
	txtScore.textAlign = "left";
	txtScore.text = "100";
	txtScore.color = "#ffffff";
	txtScore.x=txtScoreDesc.x + 190;
	txtScore.y=txtScoreDesc.y;
	
	resultPopContainer = new createjs.Container();
	resultPopContainer.visible=false;
	
	bgOverlay = new createjs.Shape();
	bgOverlay.graphics.beginFill("#000").drawRect(0, 0, canvasW, canvasH);
	bgOverlay.alpha=.5;
	
	bgPop = new createjs.Bitmap(loader.getResult("bgPop"));
	centerReg(bgPop);
	bgPop.x=canvasW/2;
	bgPop.y=canvasH/2;
	
	btnHome = new createjs.Bitmap(loader.getResult("btnHome"));
	btnReplay = new createjs.Bitmap(loader.getResult("btnReplay"));
	
	btnFacebook = new createjs.Bitmap(loader.getResult("btnFacebook"));
	btnTwitter = new createjs.Bitmap(loader.getResult("btnTwitter"));
	btnGoogle = new createjs.Bitmap(loader.getResult("btnGoogle"));
	
	centerReg(btnHome);
	centerReg(btnReplay);
	
	centerReg(btnFacebook);
	centerReg(btnTwitter);
	centerReg(btnGoogle);
	
	txtResultScoreDesc = new createjs.Text();
	txtResultScoreDesc.font = "40px jabjaiheavy";
	txtResultScoreDesc.textAlign = "center";
	txtResultScoreDesc.text = gameResultText;
	txtResultScoreDesc.color = "#ffffff";
	txtResultScoreDesc.x=canvasW/2;
	txtResultScoreDesc.y=canvasH/100*25;
	
	txtResultScore = new createjs.Text();
	txtResultScore.font = "150px jabjaiheavy";
	txtResultScore.textAlign = "center";
	txtResultScore.text = "100";
	txtResultScore.color = "#ffffff";
	txtResultScore.x=canvasW/2;
	txtResultScore.y=canvasH/100*33;
	
	txtShare= new createjs.Text();
	txtShare.font = "25px jabjaiheavy";
	txtShare.textAlign = "center";
	txtShare.text = gameShareText;
	txtShare.color = "#ffffff";
	txtShare.x=canvasW/2;
	txtShare.y=canvasH/100*53;
	
	btnHome.x=(canvasW/2)-130;
	btnReplay.x=(canvasW/2)+130;
	btnHome.y=btnReplay.y=canvasH/100*75;
	
	btnFacebook.x=canvasW/100*40;
	btnTwitter.x=canvasW/2;
	btnGoogle.x=canvasW/100*60;
	btnFacebook.y=btnTwitter.y=btnGoogle.y=canvasH/100 * 62;
	
	resultPopContainer.addChild(bgOverlay, bgPop, txtShare, btnFacebook, btnTwitter, btnGoogle, btnHome, btnReplay, txtResultScore, txtResultScoreDesc);
	
	mainContainer.addChild(landing, btnStart);
	gameContainer.addChild(planetContainer, objectContainer, txtScoreDesc, txtScore);
	canvasContainer.addChild(planet1, planet2, drag);
	canvasContainer.addChild(bg, gameContainer, mainContainer, resultPopContainer);
	stage.addChild(canvasContainer);
	
	resizeCanvas();
}


/*!
 * 
 * RESIZE GAME CANVAS - This is the function that runs to resize game canvas
 * 
 */
function resizeCanvas(){
 	if(canvasContainer!=undefined){
		canvasContainer.scaleX=canvasContainer.scaleY=scalePercent;
	}
}

/*!
 * 
 * REMOVE GAME CANVAS - This is the function that runs to remove game canvas
 * 
 */
 function removeGameCanvas(){
	 stage.autoClear = true;
	 stage.removeAllChildren();
	 stage.update();
	 createjs.Ticker.removeEventListener("tick", tick);
	 createjs.Ticker.removeEventListener("tick", stage);
 }

/*!
 * 
 * CANVAS LOOP - This is the function that runs for canvas loop
 * 
 */ 
function tick(event) {
	updateGame();
	stage.update(event);
}

/*!
 * 
 * CANVAS MISC FUNCTIONS
 * 
 */
function centerReg(obj){
	obj.regX=obj.image.naturalWidth/2;
	obj.regY=obj.image.naturalHeight/2;
}

function createHitarea(obj){
	obj.hitArea = new createjs.Shape(new createjs.Graphics().beginFill("#000").drawRect(0, 0, obj.image.naturalWidth, obj.image.naturalHeight));	
}