////////////////////////////////////////////////////////////
// CANVAS LOADER
////////////////////////////////////////////////////////////

 /*!
 * 
 * START CANVAS PRELOADER - This is the function that runs to preload canvas asserts
 * 
 */
function initPreload(){
	toggleLoader(true);
	
	checkMobileEvent();
	
	$(window).resize(function(){
		resizeGameFunc();
	});
	resizeGameFunc();
	
	loader = new createjs.LoadQueue(false);
	manifest = [{src:'assets/bg.jpg', id:'bg'},
				{src:'assets/landing.png', id:'landing'},
				{src:'assets/btnStart.png', id:'btnStart'},
				{src:'assets/planetGreen.png', id:'planetGreen'},
				{src:'assets/planetRed.png', id:'planetRed'},
				{src:'assets/planetYellow.png', id:'planetYellow'},
				
				{src:'assets/crack1.png', id:'planetCrack1'},
				{src:'assets/crack2.png', id:'planetCrack2'},
				{src:'assets/crack3.png', id:'planetCrack3'},
				{src:'assets/alert.png', id:'planetAlert'},
				
				{src:'assets/colours_green_Spritesheet7x1.png', id:'colourGreenAnime'},
				{src:'assets/colours_red_Spritesheet7x1.png', id:'colourRedAnime'},
				{src:'assets/colours_yellow_Spritesheet7x1.png', id:'colourYellowAnime'},
				
				{src:'assets/bgPop.png', id:'bgPop'},
				{src:'assets/btnHome.png', id:'btnHome'},
				{src:'assets/btnReplay.png', id:'btnReplay'},
				
				{src:'assets/btnFacebook.png', id:'btnFacebook'},
				{src:'assets/btnTwitter.png', id:'btnTwitter'},
				{src:'assets/btnGoogle.png', id:'btnGoogle'}
				];
	
	soundOn = true;		
	if($.browser.mobile || isTablet){
		if(!enableMobileSound){
			soundOn=false;
		}
	}
	
	if(soundOn){
		manifest.push({src:'assets/sounds/crack1.ogg', id:'soundCrack1'})
		manifest.push({src:'assets/sounds/crack2.ogg', id:'soundCrack2'})
		manifest.push({src:'assets/sounds/crack3.ogg', id:'soundCrack3'})
		manifest.push({src:'assets/sounds/click.ogg', id:'soundClick'})
		manifest.push({src:'assets/sounds/fail.ogg', id:'soundFail'})
		manifest.push({src:'assets/sounds/score.ogg', id:'soundScore'})
		
		createjs.Sound.alternateExtensions = ["mp3"];
		loader.installPlugin(createjs.Sound);
	}
	
	loader.addEventListener("complete", handleComplete);
	loader.addEventListener("fileload", fileComplete);
	loader.addEventListener("error",handleFileError);
	loader.on("progress", handleProgress, this);
	loader.loadManifest(manifest);
}

/*!
 * 
 * CANVAS FILE COMPLETE EVENT - This is the function that runs to update when file loaded complete
 * 
 */
function fileComplete(evt) {
	var item = evt.item;
	console.log("Event Callback file loaded ", evt.item.id);
}

/*!
 * 
 * CANVAS FILE HANDLE EVENT - This is the function that runs to handle file error
 * 
 */
function handleFileError(evt) {
	console.log("error ", evt);
}

/*!
 * 
 * CANVAS PRELOADER UPDATE - This is the function that runs to update preloder progress
 * 
 */
function handleProgress() {
	$('#mainLoader').html(Math.round(loader.progress/1*100));
}

/*!
 * 
 * CANVAS PRELOADER COMPLETE - This is the function that runs when preloader is complete
 * 
 */
function handleComplete() {
	toggleLoader(false);
	initMain();
};

/*!
 * 
 * TOGGLE LOADER - This is the function that runs to display/hide loader
 * 
 */
function toggleLoader(con){
	if(con){
		$('#mainLoader').show();
	}else{
		$('#mainLoader').hide();
	}
}